package org.sourceforge.pasclipse.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.window.Window;
//import org.eclipse.swt.graphics.Device;
//import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

public class CompileAction
	implements IObjectActionDelegate, IWorkbenchWindowActionDelegate {

	private ISelection selection = null;
	private Shell shell = new Shell();

	/**
	 * Constructor for Action1.
	 */
	public CompileAction() {
		super();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {

	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {

		ProgressMonitorDialog dialog = new ProgressMonitorDialog(shell);
		CallCompiler pascalCompiler = new CallCompiler();
		pascalCompiler.setSelection(selection);
		pascalCompiler.setShell(shell);
		//dialog.setBlockOnOpen(true);
		dialog.setCancelable(true);
		//dialog.open();
		//dialog.setBlockOnOpen(false);
		try {
			dialog.run(false, true, pascalCompiler);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		if(dialog.getReturnCode() == Window.OK && !dialog.getProgressMonitor().isCanceled())
			MessageDialog.openInformation(
						shell,
						"Pasclipse: Successful PASCAL Compilation!",
						"The launch of the compiler was finished without errors.");
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		//get workbench item from focus/selection 
		this.selection = selection;
	}

	/**
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#dispose()
	 */
	public void dispose() {
	}

	/**
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
	}

}
